program Pef_syn

 use sep
 use solver_reg_mod  
 use lv_conv2d_f90
 use cgstep_mod
 use lv_filters_mod
 
 implicit none
 
 integer :: n1, n2
 type( lv_filter2d ) :: aa 
 real, allocatable :: m(:), d(:)!,lagt(:,:),
 integer, allocatable::lagt(:,:), lag1(:), lag2(:)
 !real, allocatable,target:: m(:,:)
 integer  :: j(2), nd(2)
 real :: eps
 integer :: niter, nlag
 
 
 call sep_init()
 
 call from_param('n1', n1)
 call from_param('n2', n2)
 
 nd(1)=n1
 nd(2)=n2
 
 call from_param("niter",niter) 
 call from_param("nlag",nlag)
 call from_param("j",j)
 call from_param("eps",eps)
  
 allocate(lag1(nlag),lag2(nlag), lagt(2,nlag))
 

 call from_param("lag1",lag1)
 call from_param("lag2",lag2)
 

 lagt(1,:)=lag1
 lagt(2,:)=lag2

! Construct a filter
 aa = lv_filter2d(nd, j, lagt)
 !aa%coef2=0.

 call sep_read(aa%coef2)
 
 call conv2d_init(n1,n2)
 call conv2d_init_f(aa)
 
 allocate(m(n1*n2),d(n1*n2))
 m=0.
 
 call random_number(d)
 d=d-sum(d)/size(d)
 
 call solver_reg(m,d, conv2d_f_op, id_op,cgstep,size(m), niter,eps)


 call to_history('n1', n1)
 call to_history('n2', n2)
 call to_history('n3', 1) 
 call sep_write(m)

 call sep_close()

end program
