module mis2_mod_lv 
  use mask1 
  use lv_conv2d_f90
  use  cgstep_mod 
  use  solver_reg_mod 
  use solver_smp_mod
  implicit none
  contains
  subroutine mis2( n1, n2, niter, xx, aa, known)
    integer,                intent( in)     :: n1,n2
    integer,                intent( in)     :: niter
    type( lv_filter2d ),    intent( in)     :: aa
    logical, dimension( :), intent( in)     :: known
    real,    dimension( :), intent( in out) :: xx        ! fitting variables
    real,    dimension( :), allocatable     :: dd
    logical, dimension( :), pointer         :: msk
    integer                                 :: nx
    nx = size( xx)
    allocate( dd(nx))
    allocate(msk(nx))
    dd=xx
    msk = known
    call mask1_init( msk)
    call conv2d_init(n1,n2)
    call conv2d_init_f(aa)
    call solver_reg( m=xx, d=dd, Fop=mask1_lop, stepper=cgstep,niter=niter&
      &, Aop=conv2d_f_op, nAop=nx, eps=0.1)
    call cgstep_close( )
    deallocate( msk,dd)
  end subroutine 
end module 
