module mis3_mod_lv 
  use mask1 
  use lv_conv3d_f90
  use  cgstep_mod 
  use  solver_reg_mod 
  use solver_smp_mod
  implicit none
  contains
  subroutine mis3( n1, n2,n3, niter, xx, aa, known)
    integer,                intent( in)     :: n1,n2,n3
    integer,                intent( in)     :: niter
    type( lv_filter3d ),    intent( in)     :: aa
    logical, dimension( :), intent( in)     :: known
    real,    dimension( :), intent( in out) :: xx        ! fitting variables
    real,    dimension( :), allocatable     :: dd
    logical, dimension( :), pointer         :: msk
    integer                                 :: nx
    nx = size( xx)
    allocate( dd(nx))
    allocate(msk(nx))
    dd=xx
    msk = known
    call mask1_init( msk)
    call conv3d_init(n1,n2,n3)
    call conv3d_init_f(aa)
    !call solver_reg( m=xx, d=dd, Fop=mask1_lop, stepper=cgstep,niter=niter&
    !  &, Aop=conv3d_f_op, nAop=nx, eps=0.01)
    call solver_smp( m=xx,d=dd, Fop=conv3d_f_op, stepper=cgstep, niter=niter &
    &,Jop=mask1_lop)
    call cgstep_close( )
    deallocate( msk,dd)
  end subroutine 
end module 
